diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/he/he-phy.cc ns-3.38/src/wifi/model/he/he-phy.cc
--- ns-3.37/src/wifi/model/he/he-phy.cc	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/he/he-phy.cc	2023-03-16 20:54:23.856869200 -0700
@@ -22,7 +22,6 @@
 #include "he-phy.h"
 
 #include "he-configuration.h"
-#include "he-ppdu.h"
 #include "obss-pd-algorithm.h"
 
 #include "ns3/ap-wifi-mac.h"
@@ -78,7 +77,9 @@
 
 HePhy::HePhy(bool buildModeList /* = true */)
     : VhtPhy(false), // don't add VHT modes to list
-      m_trigVectorExpirationTime(Seconds(0)),
+      m_trigVector(std::nullopt),
+      m_trigVectorExpirationTime(std::nullopt),
+      m_currentTxVector(std::nullopt),
       m_rxHeTbPpdus(0),
       m_lastPer20MHzDurations()
 {
@@ -154,7 +155,7 @@
     uint8_t smallestMcs = 5; // maximum MCS for HE-SIG-B
     for (auto& info : txVector.GetHeMuUserInfoMap())
     {
-        smallestMcs = std::min(smallestMcs, info.second.mcs.GetMcsValue());
+        smallestMcs = std::min(smallestMcs, info.second.mcs);
     }
     switch (smallestMcs)
     {
@@ -218,7 +219,7 @@
 Time
 HePhy::GetSigBDuration(const WifiTxVector& txVector) const
 {
-    if (txVector.IsDlMu()) // See section 27.3.10.8 of IEEE 802.11ax draft 4.0.
+    if (ns3::IsDlMu(txVector.GetPreambleType())) // See section 27.3.11.8 of IEEE 802.11ax-2021
     {
         NS_ASSERT(txVector.GetModulationClass() >= WIFI_MOD_CLASS_HE);
 
@@ -287,7 +288,6 @@
 Time
 HePhy::CalculateNonOfdmaDurationForHeTb(const WifiTxVector& txVector) const
 {
-    NS_ABORT_IF(!txVector.IsUlMu() || (txVector.GetModulationClass() < WIFI_MOD_CLASS_HE));
     Time duration = GetDuration(WIFI_PPDU_FIELD_PREAMBLE, txVector) +
                     GetDuration(WIFI_PPDU_FIELD_NON_HT_HEADER, txVector) +
                     GetDuration(WIFI_PPDU_FIELD_SIG_A, txVector);
@@ -297,7 +297,6 @@
 Time
 HePhy::CalculateNonOfdmaDurationForHeMu(const WifiTxVector& txVector) const
 {
-    NS_ABORT_IF(!txVector.IsDlMu() || (txVector.GetModulationClass() < WIFI_MOD_CLASS_HE));
     Time duration = GetDuration(WIFI_PPDU_FIELD_PREAMBLE, txVector) +
                     GetDuration(WIFI_PPDU_FIELD_NON_HT_HEADER, txVector) +
                     GetDuration(WIFI_PPDU_FIELD_SIG_A, txVector) +
@@ -322,9 +321,16 @@
 void
 HePhy::SetTrigVector(const WifiTxVector& trigVector, Time validity)
 {
+    NS_LOG_FUNCTION(this << trigVector << validity);
+    NS_ASSERT_MSG(trigVector.GetGuardInterval() > 800,
+                  "Invalid guard interval " << trigVector.GetGuardInterval());
+    if (auto mac = m_wifiPhy->GetDevice()->GetMac(); mac && mac->GetTypeOfStation() != AP)
+    {
+        return;
+    }
     m_trigVector = trigVector;
     m_trigVectorExpirationTime = Simulator::Now() + validity;
-    NS_LOG_FUNCTION(this << m_trigVector << m_trigVectorExpirationTime.As(Time::US));
+    NS_LOG_FUNCTION(this << m_trigVector.value() << m_trigVectorExpirationTime->As(Time::US));
 }
 
 Ptr<WifiPpdu>
@@ -338,8 +344,7 @@
                           ppduDuration,
                           m_wifiPhy->GetPhyBand(),
                           ObtainNextUid(txVector),
-                          HePpdu::PSD_NON_HE_PORTION,
-                          m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20));
+                          HePpdu::PSD_NON_HE_PORTION);
 }
 
 void
@@ -348,10 +353,10 @@
                             Time rxDuration)
 {
     NS_LOG_FUNCTION(this << ppdu << rxDuration);
-    const WifiTxVector& txVector = ppdu->GetTxVector();
+    const auto& txVector = ppdu->GetTxVector();
     auto hePpdu = DynamicCast<const HePpdu>(ppdu);
     NS_ASSERT(hePpdu);
-    HePpdu::TxPsdFlag psdFlag = hePpdu->GetTxPsdFlag();
+    const auto psdFlag = hePpdu->GetTxPsdFlag();
     if (psdFlag == HePpdu::PSD_HE_PORTION)
     {
         NS_ASSERT(txVector.GetModulationClass() >= WIFI_MOD_CLASS_HE);
@@ -446,19 +451,35 @@
     // detection window. If a preamble is received after the preamble detection window, it is stored
     // anyway because this is needed for HE TB PPDUs in order to properly update the received power
     // in InterferenceHelper. The map is cleaned anyway at the end of the current reception.
-    if (ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU)
-    {
-        auto uidPreamblePair = std::make_pair(ppdu->GetUid(), ppdu->GetPreamble());
-        const WifiTxVector& txVector = ppdu->GetTxVector();
-        Time rxDuration = CalculateNonOfdmaDurationForHeTb(
-            txVector); // the OFDMA part of the transmission will be added later on
-        const auto& currentPreambleEvents = GetCurrentPreambleEvents();
-        auto it = currentPreambleEvents.find(uidPreamblePair);
+    auto uidPreamblePair = std::make_pair(ppdu->GetUid(), ppdu->GetPreamble());
+    const auto& currentPreambleEvents = GetCurrentPreambleEvents();
+    auto it = currentPreambleEvents.find(uidPreamblePair);
+    bool isResponseToTrigger = (m_previouslyTxPpduUid == ppdu->GetUid());
+    if (ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU || isResponseToTrigger)
+    {
+        const auto& txVector = ppdu->GetTxVector();
+        Time rxDuration;
+        if (ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU)
+        {
+            rxDuration = CalculateNonOfdmaDurationForHeTb(
+                txVector); // the OFDMA part of the transmission will be added later on
+        }
+        else
+        {
+            rxDuration = ppdu->GetTxDuration();
+        }
         if (it != currentPreambleEvents.end())
         {
-            NS_LOG_DEBUG("Received another HE TB PPDU for UID "
-                         << ppdu->GetUid() << " from STA-ID " << ppdu->GetStaId()
-                         << " and BSS color " << +txVector.GetBssColor());
+            if (ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU)
+            {
+                NS_LOG_DEBUG("Received another HE TB PPDU for UID "
+                             << ppdu->GetUid() << " from STA-ID " << ppdu->GetStaId()
+                             << " and BSS color " << +txVector.GetBssColor());
+            }
+            else
+            {
+                NS_LOG_DEBUG("Received another response to a trigger frame " << ppdu->GetUid());
+            }
             event = it->second;
 
             auto heConfiguration = m_wifiPhy->GetDevice()->GetHeConfiguration();
@@ -489,25 +510,40 @@
                 UpdateInterferenceEvent(event, rxPowersW);
             }
 
-            if (GetCurrentEvent() && (GetCurrentEvent()->GetPpdu()->GetUid() != ppdu->GetUid()))
+            if (ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU && GetCurrentEvent() &&
+                (GetCurrentEvent()->GetPpdu()->GetUid() != ppdu->GetUid()))
             {
                 NS_LOG_DEBUG("Drop packet because already receiving another HE TB PPDU");
                 m_wifiPhy->NotifyRxDrop(GetAddressedPsduInPpdu(ppdu), RXING);
             }
+            else if (isResponseToTrigger && GetCurrentEvent() &&
+                     (GetCurrentEvent()->GetPpdu()->GetUid() != ppdu->GetUid()))
+            {
+                NS_LOG_DEBUG(
+                    "Drop packet because already receiving another response to a trigger frame");
+                m_wifiPhy->NotifyRxDrop(GetAddressedPsduInPpdu(ppdu), RXING);
+            }
             return nullptr;
         }
         else
         {
-            NS_LOG_DEBUG("Received a new HE TB PPDU for UID "
-                         << ppdu->GetUid() << " from STA-ID " << ppdu->GetStaId()
-                         << " and BSS color " << +txVector.GetBssColor());
+            if (ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU)
+            {
+                NS_LOG_DEBUG("Received a new HE TB PPDU for UID "
+                             << ppdu->GetUid() << " from STA-ID " << ppdu->GetStaId()
+                             << " and BSS color " << +txVector.GetBssColor());
+            }
+            else
+            {
+                NS_LOG_DEBUG("Received response to a trigger frame for UID " << ppdu->GetUid());
+            }
             event = CreateInterferenceEvent(ppdu, txVector, rxDuration, rxPowersW);
             AddPreambleEvent(event);
         }
     }
     else if (ppdu->GetType() == WIFI_PPDU_TYPE_DL_MU)
     {
-        const WifiTxVector& txVector = ppdu->GetTxVector();
+        const auto& txVector = ppdu->GetTxVector();
         Time rxDuration = CalculateNonOfdmaDurationForHeMu(
             txVector); // the OFDMA part of the transmission will be added later on
         event = CreateInterferenceEvent(ppdu, ppdu->GetTxVector(), rxDuration, rxPowersW);
@@ -515,7 +551,19 @@
     }
     else
     {
-        event = PhyEntity::DoGetEvent(ppdu, rxPowersW);
+        if (it == currentPreambleEvents.end())
+        {
+            event = PhyEntity::DoGetEvent(ppdu, rxPowersW);
+        }
+        else
+        {
+            NS_LOG_DEBUG(
+                "Update received power of the event associated to these UL transmissions with UID "
+                << ppdu->GetUid());
+            event = it->second;
+            UpdateInterferenceEvent(event, rxPowersW);
+            return nullptr;
+        }
     }
     return event;
 }
@@ -556,7 +604,7 @@
     }
     else if (ppdu->GetType() == WIFI_PPDU_TYPE_DL_MU)
     {
-        Ptr<StaWifiMac> mac = DynamicCast<StaWifiMac>(m_wifiPhy->GetDevice()->GetMac());
+        auto mac = DynamicCast<StaWifiMac>(m_wifiPhy->GetDevice()->GetMac());
         if (mac && mac->IsAssociated())
         {
             return mac->GetAssociationId();
@@ -609,18 +657,21 @@
 
         // When SIG-A is decoded, we know the type of frame being received. If we stored a
         // valid TRIGVECTOR and we are not receiving a TB PPDU, we drop the frame.
-        if (m_trigVectorExpirationTime >= Simulator::Now() && !txVector.IsUlMu())
+        Ptr<const WifiPpdu> ppdu = event->GetPpdu();
+        if (m_trigVectorExpirationTime.has_value() &&
+            (m_trigVectorExpirationTime.value() >= Simulator::Now()) &&
+            (ppdu->GetType() != WIFI_PPDU_TYPE_UL_MU))
         {
             NS_LOG_DEBUG("Expected an HE TB PPDU, receiving a " << txVector.GetPreambleType());
             return PhyFieldRxStatus(false, FILTERED, DROP);
         }
 
-        Ptr<const WifiPpdu> ppdu = event->GetPpdu();
-        if (txVector.IsUlMu())
+        if (ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU)
         {
             NS_ASSERT(txVector.GetModulationClass() >= WIFI_MOD_CLASS_HE);
             // check that the stored TRIGVECTOR is still valid
-            if (m_trigVectorExpirationTime < Simulator::Now())
+            if (!m_trigVectorExpirationTime.has_value() ||
+                (m_trigVectorExpirationTime < Simulator::Now()))
             {
                 NS_LOG_DEBUG("No valid TRIGVECTOR, the PHY was not expecting a TB PPDU");
                 return PhyFieldRxStatus(false, FILTERED, DROP);
@@ -630,28 +681,32 @@
             // OBSS, as BSS Colors are not guaranteed to be different for all APs in
             // range (an example is when BSS Color is 0). We can detect this situation
             // by comparing the TRIGVECTOR with the TXVECTOR of the TB PPDU being received
-            if (m_trigVector.GetChannelWidth() != txVector.GetChannelWidth())
+            NS_ABORT_IF(!m_trigVector.has_value());
+            if (m_trigVector->GetChannelWidth() != txVector.GetChannelWidth())
             {
                 NS_LOG_DEBUG("Received channel width different than in TRIGVECTOR");
                 return PhyFieldRxStatus(false, FILTERED, DROP);
             }
-            if (m_trigVector.GetLength() != txVector.GetLength())
+            if (m_trigVector->GetLength() != txVector.GetLength())
             {
                 NS_LOG_DEBUG("Received UL Length (" << txVector.GetLength()
                                                     << ") different than in TRIGVECTOR ("
-                                                    << m_trigVector.GetLength() << ")");
+                                                    << m_trigVector->GetLength() << ")");
                 return PhyFieldRxStatus(false, FILTERED, DROP);
             }
             uint16_t staId = ppdu->GetStaId();
-            if (m_trigVector.GetHeMuUserInfoMap().find(staId) ==
-                    m_trigVector.GetHeMuUserInfoMap().end() ||
-                m_trigVector.GetHeMuUserInfo(staId) != txVector.GetHeMuUserInfo(staId))
+            if (m_trigVector->GetHeMuUserInfoMap().find(staId) ==
+                m_trigVector->GetHeMuUserInfoMap().end())
             {
-                NS_LOG_DEBUG(
-                    "User Info map of TB PPDU being received differs from that of TRIGVECTOR");
+                NS_LOG_DEBUG("TB PPDU received from un unexpected STA ID");
                 return PhyFieldRxStatus(false, FILTERED, DROP);
             }
 
+            NS_ASSERT(txVector.GetGuardInterval() == m_trigVector->GetGuardInterval());
+            NS_ASSERT(txVector.GetMode(staId) == m_trigVector->GetMode(staId));
+            NS_ASSERT(txVector.GetNss(staId) == m_trigVector->GetNss(staId));
+            NS_ASSERT(txVector.GetHeMuUserInfo(staId) == m_trigVector->GetHeMuUserInfo(staId));
+
             m_currentMuPpduUid =
                 ppdu->GetUid(); // to be able to correctly schedule start of OFDMA payload
         }
@@ -706,14 +761,29 @@
             return PhyFieldRxStatus(false, FILTERED, DROP);
         }
     }
-    m_currentMuPpduUid =
-        event->GetPpdu()->GetUid(); // to be able to correctly schedule start of OFDMA payload
+    if (event->GetTxVector().IsDlMu())
+    {
+        // When including a Trigger Frame, a DL MU PPDU solicits a TB PPDU.
+        // NOTE that the 'if' condition above is not needed for HE because SIG-B is only
+        // included in HE MU PPDUs, but it is necessary for EHT to avoid that a non-AP
+        // STA receiving a Trigger Frame sent as an EHT SU transmission (which carries
+        // the EHT-SIG field) stores the PPDU UID and uses it later to schedule the
+        // reception of the OFDMA payload of the TB PPDU (see HePhy::StartReceivePreamble())
+        // despite it lacks the TRIGVECTOR.
+        m_currentMuPpduUid =
+            event->GetPpdu()->GetUid(); // to be able to correctly schedule start of OFDMA payload
+    }
     return status;
 }
 
 bool
 HePhy::IsConfigSupported(Ptr<const WifiPpdu> ppdu) const
 {
+    if (ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU)
+    {
+        return true; // evaluated in ProcessSigA
+    }
+
     const WifiTxVector& txVector = ppdu->GetTxVector();
     uint16_t staId = GetStaId(ppdu);
     WifiMode txMode = txVector.GetMode(staId);
@@ -749,7 +819,7 @@
 HePhy::DoStartReceivePayload(Ptr<Event> event)
 {
     NS_LOG_FUNCTION(this << *event);
-    const WifiTxVector& txVector = event->GetTxVector();
+    const auto& txVector = event->GetTxVector();
 
     if (!txVector.IsMu())
     {
@@ -782,8 +852,7 @@
     }
     Time timeToEndRx = payloadDuration + maxOffset;
 
-    bool isAp = (bool)(DynamicCast<ApWifiMac>(m_wifiPhy->GetDevice()->GetMac()));
-    if (!isAp)
+    if (m_wifiPhy->GetDevice()->GetMac()->GetTypeOfStation() != AP)
     {
         NS_LOG_DEBUG("Ignore HE TB PPDU payload received by STA but keep state in Rx");
         NotifyPayloadBegin(txVector, timeToEndRx);
@@ -866,8 +935,8 @@
         if (m_endRxPayloadEvents.empty())
         {
             // We've got the last PPDU of the UL-OFDMA transmission.
-            // Indicate a successfull reception is terminated if at least one HE TB PPDU
-            // has been successfully received, otherwise indicate a unsuccessfull reception is
+            // Indicate a successful reception is terminated if at least one HE TB PPDU
+            // has been successfully received, otherwise indicate a unsuccessful reception is
             // terminated.
             if (m_rxHeTbPpdus > 0)
             {
@@ -891,6 +960,7 @@
 void
 HePhy::StartReceiveOfdmaPayload(Ptr<Event> event)
 {
+    NS_LOG_FUNCTION(this << event);
     Ptr<const WifiPpdu> ppdu = event->GetPpdu();
     const RxPowerWattPerChannelBand& rxPowersW = event->GetRxPowerWPerBand();
     // The total RX power corresponds to the maximum over all the bands.
@@ -952,8 +1022,10 @@
     HeRu::RuSpec ru = txVector.GetRu(staId);
     uint16_t channelWidth = txVector.GetChannelWidth();
     NS_ASSERT(channelWidth <= m_wifiPhy->GetChannelWidth());
-    HeRu::SubcarrierGroup group =
-        HeRu::GetSubcarrierGroup(channelWidth, ru.GetRuType(), ru.GetPhyIndex());
+    HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup(
+        channelWidth,
+        ru.GetRuType(),
+        ru.GetPhyIndex(channelWidth, m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20)));
     HeRu::SubcarrierRange range = std::make_pair(group.front().first, group.back().second);
     // for a TX spectrum, the guard bandwidth is a function of the transmission channel width
     // and the spectrum width equals the transmission channel width (hence bandIndex equals 0)
@@ -970,8 +1042,10 @@
     HeRu::RuSpec ru = txVector.GetRu(staId);
     uint16_t channelWidth = txVector.GetChannelWidth();
     NS_ASSERT(channelWidth <= m_wifiPhy->GetChannelWidth());
-    HeRu::SubcarrierGroup group =
-        HeRu::GetSubcarrierGroup(channelWidth, ru.GetRuType(), ru.GetPhyIndex());
+    HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup(
+        channelWidth,
+        ru.GetRuType(),
+        ru.GetPhyIndex(channelWidth, m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20)));
     HeRu::SubcarrierRange range = std::make_pair(group.front().first, group.back().second);
     // for an RX spectrum, the guard bandwidth is a function of the operating channel width
     // and the spectrum width equals the operating channel width
@@ -996,11 +1070,12 @@
     // Find the RU that encompasses the non-OFDMA part of the HE TB PPDU for the STA-ID
     HeRu::RuSpec nonOfdmaRu =
         HeRu::FindOverlappingRu(channelWidth, ru, HeRu::GetRuType(nonOfdmaWidth));
-    nonOfdmaRu.SetPhyIndex(channelWidth,
-                           m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20));
 
-    HeRu::SubcarrierGroup groupPreamble =
-        HeRu::GetSubcarrierGroup(channelWidth, nonOfdmaRu.GetRuType(), nonOfdmaRu.GetPhyIndex());
+    HeRu::SubcarrierGroup groupPreamble = HeRu::GetSubcarrierGroup(
+        channelWidth,
+        nonOfdmaRu.GetRuType(),
+        nonOfdmaRu.GetPhyIndex(channelWidth,
+                               m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20)));
     HeRu::SubcarrierRange range =
         std::make_pair(groupPreamble.front().first, groupPreamble.back().second);
     return m_wifiPhy->ConvertHeRuSubcarriers(
@@ -1227,9 +1302,8 @@
 {
     NS_LOG_FUNCTION(this << txVector);
     uint64_t uid;
-    if (txVector.IsUlMu())
+    if (txVector.IsUlMu() || txVector.IsTriggerResponding())
     {
-        NS_ASSERT(txVector.GetModulationClass() >= WIFI_MOD_CLASS_HE);
         // Use UID of PPDU containing trigger frame to identify resulting HE TB PPDUs, since the
         // latter should immediately follow the former
         uid = m_wifiPhy->GetPreviouslyRxPpduUid();
@@ -1244,13 +1318,23 @@
 }
 
 Ptr<SpectrumValue>
+HePhy::GetTxPowerSpectralDensity(double txPowerW, Ptr<const WifiPpdu> ppdu) const
+{
+    auto hePpdu = DynamicCast<const HePpdu>(ppdu);
+    NS_ASSERT(hePpdu);
+    HePpdu::TxPsdFlag flag = hePpdu->GetTxPsdFlag();
+    return GetTxPowerSpectralDensity(txPowerW, ppdu, flag);
+}
+
+Ptr<SpectrumValue>
 HePhy::GetTxPowerSpectralDensity(double txPowerW,
                                  Ptr<const WifiPpdu> ppdu,
-                                 const WifiTxVector& txVector) const
+                                 HePpdu::TxPsdFlag flag) const
 {
+    const auto& txVector = ppdu->GetTxVector();
     uint16_t centerFrequency = GetCenterFrequencyForChannelWidth(txVector);
     uint16_t channelWidth = txVector.GetChannelWidth();
-    NS_LOG_FUNCTION(this << centerFrequency << channelWidth << txPowerW);
+    NS_LOG_FUNCTION(this << centerFrequency << channelWidth << txPowerW << txVector);
     const auto& puncturedSubchannels = txVector.GetInactiveSubchannels();
     if (!puncturedSubchannels.empty())
     {
@@ -1261,9 +1345,6 @@
         NS_ASSERT(
             !puncturedSubchannels.at(p20IndexInBitmap)); // the primary channel cannot be punctured
     }
-    auto hePpdu = DynamicCast<const HePpdu>(ppdu);
-    NS_ASSERT(hePpdu);
-    HePpdu::TxPsdFlag flag = hePpdu->GetTxPsdFlag();
     const auto& txMaskRejectionParams = GetTxMaskRejectionParams();
     switch (ppdu->GetType())
     {
@@ -1271,7 +1352,7 @@
         if (flag == HePpdu::PSD_NON_HE_PORTION)
         {
             // non-OFDMA portion is sent only on the 20 MHz channels covering the RU
-            const uint16_t staId = GetStaId(hePpdu);
+            const uint16_t staId = GetStaId(ppdu);
             centerFrequency = GetCenterFrequencyForNonOfdmaPart(txVector, staId);
             const uint16_t ruWidth = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
             channelWidth = (ruWidth < 20) ? 20 : ruWidth;
@@ -1287,10 +1368,7 @@
         }
         else
         {
-            const auto band =
-                GetRuBandForTx(ppdu->GetTxVector(),
-                               GetStaId(hePpdu)); // Use TXVECTOR from PPDU since the one passed by
-                                                  // the MAC does not have PHY index set
+            const auto band = GetRuBandForTx(txVector, GetStaId(ppdu));
             return WifiSpectrumValueHelper::CreateHeMuOfdmTxPowerSpectralDensity(
                 centerFrequency,
                 channelWidth,
@@ -1355,47 +1433,84 @@
         // Obtain the index of the non-OFDMA portion
         HeRu::RuSpec nonOfdmaRu =
             HeRu::FindOverlappingRu(currentWidth, ru, HeRu::GetRuType(nonOfdmaWidth));
-        nonOfdmaRu.SetPhyIndex(currentWidth,
-                               m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20));
 
         uint16_t startingFrequency = centerFrequency - (currentWidth / 2);
         centerFrequency =
-            startingFrequency + nonOfdmaWidth * (nonOfdmaRu.GetPhyIndex() - 1) + nonOfdmaWidth / 2;
+            startingFrequency +
+            nonOfdmaWidth * (nonOfdmaRu.GetPhyIndex(
+                                 currentWidth,
+                                 m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20)) -
+                             1) +
+            nonOfdmaWidth / 2;
     }
     return centerFrequency;
 }
 
 void
-HePhy::StartTx(Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector)
+HePhy::StartTx(Ptr<const WifiPpdu> ppdu)
 {
     NS_LOG_FUNCTION(this << ppdu);
+    const auto& txVector = ppdu->GetTxVector();
+    if (auto mac = m_wifiPhy->GetDevice()->GetMac(); mac && (mac->GetTypeOfStation() == AP))
+    {
+        m_currentTxVector = txVector;
+    }
     if (ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU || ppdu->GetType() == WIFI_PPDU_TYPE_DL_MU)
     {
+        auto nonOfdmaTxPowerDbm =
+            m_wifiPhy->GetTxPowerForTransmission(ppdu) + m_wifiPhy->GetTxGain();
+
+        // temporarily set WifiPpdu flag to PSD_HE_PORTION for correct calculation of the OFDMA TX
+        // power
+        auto hePpdu = DynamicCast<const HePpdu>(ppdu);
+        NS_ASSERT(hePpdu);
+        hePpdu->SetTxPsdFlag(HePpdu::PSD_HE_PORTION);
+        auto ofdmaTxPowerDbm = m_wifiPhy->GetTxPowerForTransmission(ppdu) + m_wifiPhy->GetTxGain();
+        hePpdu->SetTxPsdFlag(HePpdu::PSD_NON_HE_PORTION);
+
         // non-OFDMA part
-        Time nonOfdmaDuration = ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU
+        auto nonOfdmaDuration = ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU
                                     ? CalculateNonOfdmaDurationForHeTb(txVector)
                                     : CalculateNonOfdmaDurationForHeMu(txVector);
-        Transmit(nonOfdmaDuration, ppdu, txVector, "non-OFDMA transmission");
+        auto nonOfdmaTxPowerSpectrum =
+            GetTxPowerSpectralDensity(DbmToW(nonOfdmaTxPowerDbm), ppdu, HePpdu::PSD_NON_HE_PORTION);
+        Transmit(nonOfdmaDuration,
+                 ppdu,
+                 nonOfdmaTxPowerDbm,
+                 nonOfdmaTxPowerSpectrum,
+                 "non-OFDMA transmission");
 
         // OFDMA part
-        auto hePpdu = DynamicCast<HePpdu>(ppdu->Copy()); // since flag will be modified
-        NS_ASSERT(hePpdu);
-        hePpdu->SetTxPsdFlag(HePpdu::PSD_HE_PORTION);
-        Time ofdmaDuration = ppdu->GetTxDuration() - nonOfdmaDuration;
+        auto ofdmaDuration = ppdu->GetTxDuration() - nonOfdmaDuration;
+        auto ofdmaTxPowerSpectrum =
+            GetTxPowerSpectralDensity(DbmToW(ofdmaTxPowerDbm), ppdu, HePpdu::PSD_HE_PORTION);
         Simulator::Schedule(nonOfdmaDuration,
-                            &PhyEntity::Transmit,
+                            &HePhy::StartTxOfdma,
                             this,
-                            ofdmaDuration,
-                            hePpdu,
-                            txVector,
-                            "OFDMA transmission");
+                            ppdu,
+                            ofdmaTxPowerDbm,
+                            ofdmaTxPowerSpectrum,
+                            ofdmaDuration);
     }
     else
     {
-        PhyEntity::StartTx(ppdu, txVector);
+        PhyEntity::StartTx(ppdu);
     }
 }
 
+void
+HePhy::StartTxOfdma(Ptr<const WifiPpdu> ppdu,
+                    double txPowerDbm,
+                    Ptr<SpectrumValue> txPowerSpectrum,
+                    Time ofdmaDuration)
+{
+    NS_LOG_FUNCTION(this << ppdu << txPowerDbm << ofdmaDuration);
+    auto hePpdu = DynamicCast<const HePpdu>(ppdu);
+    NS_ASSERT(hePpdu);
+    hePpdu->SetTxPsdFlag(HePpdu::PSD_HE_PORTION);
+    Transmit(ofdmaDuration, ppdu, txPowerDbm, txPowerSpectrum, "OFDMA transmission");
+}
+
 Time
 HePhy::CalculateTxDuration(WifiConstPsduMap psduMap,
                            const WifiTxVector& txVector,
@@ -1670,7 +1785,7 @@
 HePhy::GetSigBFieldSize(const WifiTxVector& txVector)
 {
     NS_ASSERT(txVector.GetModulationClass() >= WIFI_MOD_CLASS_HE);
-    NS_ASSERT(txVector.IsDlMu());
+    NS_ASSERT(ns3::IsDlMu(txVector.GetPreambleType()));
 
     // Compute the number of bits used by common field.
     // Assume that compression bit in HE-SIG-A is not set (i.e. not
@@ -1700,6 +1815,64 @@
 
     return commonFieldSize + userSpecificFieldSize;
 }
+
+bool
+HePhy::CanStartRx(Ptr<const WifiPpdu> ppdu, uint16_t txChannelWidth) const
+{
+    /*
+     * The PHY shall not issue a PHY-RXSTART.indication primitive in response to a PPDU
+     * that does not overlap the primary channel, unless the PHY at an AP receives the
+     * HE TB PPDU solicited by the AP. For the HE TB PPDU solicited by the AP, the PHY
+     * shall issue a PHY-RXSTART.indication primitive for a PPDU received in the primary
+     * or at the secondary 20 MHz channel, the secondary 40 MHz channel, or the secondary
+     * 80 MHz channel.
+     */
+    Ptr<WifiMac> mac = m_wifiPhy->GetDevice() ? m_wifiPhy->GetDevice()->GetMac() : nullptr;
+    if (ppdu->GetTxVector().IsUlMu() && mac && mac->GetTypeOfStation() == AP)
+    {
+        return true;
+    }
+    return PhyEntity::CanStartRx(ppdu, txChannelWidth);
+}
+
+Ptr<const WifiPpdu>
+HePhy::GetRxPpduFromTxPpdu(Ptr<const WifiPpdu> ppdu)
+{
+    if (ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU)
+    {
+        Ptr<const WifiPpdu> rxPpdu;
+        if ((m_trigVectorExpirationTime.has_value()) &&
+            (Simulator::Now() <= m_trigVectorExpirationTime.value()))
+        {
+            // We only copy if the AP that is expecting a HE TB PPDU, since the content
+            // of the TXVECTOR is reconstructed from the TRIGVECTOR, hence the other RX
+            // PHYs should not have this information.
+            rxPpdu = ppdu->Copy();
+        }
+        else
+        {
+            rxPpdu = ppdu;
+        }
+        auto hePpdu = DynamicCast<const HePpdu>(rxPpdu);
+        NS_ASSERT(hePpdu);
+        hePpdu->UpdateTxVectorForUlMu(m_trigVector);
+        return rxPpdu;
+    }
+    else if (auto txVector = ppdu->GetTxVector();
+             m_currentTxVector.has_value() &&
+             (m_previouslyTxPpduUid == ppdu->GetUid()) &&         // response to a trigger frame
+             (txVector.GetModulationClass() < WIFI_MOD_CLASS_HT)) // PPDU is a non-HT (duplicate)
+    {
+        auto triggerChannelWidth = m_currentTxVector->GetChannelWidth();
+        if (txVector.GetChannelWidth() != triggerChannelWidth)
+        {
+            txVector.SetChannelWidth(triggerChannelWidth);
+            ppdu->UpdateTxVector(txVector);
+        }
+    }
+    return PhyEntity::GetRxPpduFromTxPpdu(ppdu);
+}
+
 } // namespace ns3
 
 namespace
